<template>
  <q-page class="q-mx-md">
    <div class="row">
      <q-card class="q-ma-md q-pa-md col " flat>
        <p class="row">Hier kan je een taxonomie rechtstreeks vanaf een website laden. Gezien de grote hoeveelheid
          onbekende factoren die hier mee kunnen spelen bestaat enkel de mogelijkheid om de taxonomie te parsen en
          valideren.
          Het opslaan en bekijken in Nessie is, zelfs voor die gevallen waar we de eindstreep halen, een brug te ver /
          te complex.
        </p>
        <q-form class="row">
          <div class="col-8">
            <q-input name="urls" type="url" v-model="url" title="URL van een entrypoint"
                     @blur="parse_list = [url]" label="URL van een entrypoint" clearable></q-input>
          </div>
          <div class="col-1"></div>
          <div class="col-3">
            <q-btn :label="btn_label" @click="parse_from_url" color="red" class="q-my-md q-px-md"/>
          </div>
          <div class="row">
            <div class="col">
              <q-checkbox label="Parse" v-model="xbrl_cli.parse" disable></q-checkbox>
            </div>
            <div class="col">
              <q-checkbox label="Valideer" v-model="xbrl_cli.validate_nt" @click="set_btn_label"></q-checkbox>
            </div>
          </div>
        </q-form>
      </q-card>

      <ParseConfiguration :configuration="data.taxonomy.configuration" :xbrl_cli="xbrl_cli"
                          :parse_list="parse_list"></ParseConfiguration>

    </div>
  </q-page>
</template>


<script>
import {api} from "boot/axios";
import ParseConfiguration from "components/ParseConfiguration";
import {useStore} from 'vuex'
import {Cookies} from "quasar";


export default {
  name: "ParseByUrl",
  components: {ParseConfiguration},
  created() {
    this.fetchData()
  },
  data() {
    return {
      url: "http://www.nltaxonomie.nl/nt17/kvk/20221214/entrypoints/kvk-rpt-jaarverantwoording-2022-nlgaap-micro-publicatiestukken.xsd",
      parse_list: [],
      xbrl_cli: {
        parse: true,
        store: false,
        validate_nt: false,
        compare: false,
        run_id: "",
        build_ep_list: false,
        alfa: false,
        beta: false,
        final: true,
        nt_version: "Unknown",
        taxonomy_package: "",
        notify: "",
        ep_list: [],
      },
      data: {taxonomy: Object},
      btn_label: "Parse",
    }
  },
  methods: {
    fetchData: function () {
      let headers = {}
      if (this.$store.state.user.token) {
        headers = {"Authorization": "Bearer " + this.$store.state.user.token}
      }
      api
        .get("/admin/taxonomy", {headers})
        .then(response => {
          this.data.taxonomy = response.data
        })
        .catch((error) => {
          if (error.response.status == 401) {
            this.$store.commit('user/LOGOUT', '')
            if (Cookies.has('kc_token')) {
              Cookies.remove('kc_token')
            }
            this.$store.commit('user/LOGIN_ERROR', 'Sessie verlopen, log opnieuw in')
          }
        })

    },
    parse_from_url: function () {
      console.log("Should get: " + this.url)
      let headers = {}
      if (this.$store.state.user.token) {
        console.log("Authorizing")
        console.log(this.xbrl_cli.ep_list)
        headers = {"Authorization": "Bearer " + this.$store.state.user.token}
      }
      this.xbrl_cli.ep_list = [this.url]
      api
        .post("/admin/load_tax", {
          "conf": this.data.taxonomy,
          "cli": this.xbrl_cli,
          "ep_list": [this.url]
        }, {headers})
      this.$router.push({path: this.$route.fullPath, query: {pos: 0}})
    },
    set_btn_label: function () {
      if (this.xbrl_cli.validate_nt) {
        this.btn_label = "Parse en valideer"
      } else {
        this.btn_label = "Parse"
      }
    },

  }
}
</script>

<style scoped>

</style>
